
package de.ivu.elect.presentation.kandidatur;

import static org.apache.commons.lang3.StringUtils.isBlank;

import java.util.Collection;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gruppe.entity.Gruppe;
import de.ivu.elect.business.kandidatur.boundary.KandidaturConversationSelect;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.personenpruefung.boundary.PersonenKonfliktConversationSelect;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.business.wahl.entity.Wahlart;
import de.ivu.elect.business.wahlvorschlag.boundary.EinzelkandidatEdit;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagsdokumentExtendedDAO;
import de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat;
import de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagReihenfolgeBestaetigenEvent;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlagsdokument;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.gebietsbaum.GebietNummerFormatter;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.kandidatur.form.EinzelkandidaturViewFormBuilder;
import de.ivu.elect.presentation.wahlvorschlag.form.WahlvorschlagsdokumenteViewFormBuilder;

@OnlineHilfeId(value = "480", mehrfachVergebenOk = true)
@Named(EinzelkandidaturEditView.COMPONENT_NAME)
@View(viewId = EinzelkandidaturEditView.VIEW_ID, useCase = UseCasePermission.DIREKTKANDIDATUR_EDIT)
public class EinzelkandidaturEditView extends AbstractDirektkandidaturEditView {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "einzelkandidaturEditView";

  public static final String VIEW_ID = "/kandidatur/einzelkandidatur-edit.xhtml";

  @Inject
  protected transient WahlvorschlagsdokumentExtendedDAO wahlvorschlagsdokumentExtendedDAO;

  @Inject
  protected transient KandidaturConversationSelect uebergeordneteKandidaturSelect;

  @Inject
  protected transient EinzelkandidatEdit einzelkandidatEdit;

  @Inject
  protected transient EinzelkandidaturViewFormBuilder einzelkandidaturViewFormBuilder;

  @Inject
  protected transient WahlvorschlagsdokumenteViewFormBuilder wahlvorschlagsdokumenteViewFormBuilder;

  @Inject
  protected transient GebietNummerFormatter gebietNummerFormatter;

  @Inject
  protected transient ErsatzkandidaturCreateViewResolver ersatzkandidaturCreateViewResolver;

  @Inject
  protected transient PersonenKonfliktConversationSelect personenKonfliktConversationSelect;

  @Inject
  protected transient WahlvorschlagReihenfolgeBestaetigenEvent wahlvorschlagReihenfolgeBestaetigenEvent;

  private Collection<Wahlvorschlagsdokument> wahlvorschlagsdokumente;

  public EinzelkandidaturEditView() {
    super();
  }

  /*
   * Beachte: Muss überschrieben werden, da die VIEW_ID eine andere als im AbstractDirektkandidaturEditView ist.
   */
  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  @Override
  @PreConditionCheck
  public String checkPreCondition() {
    super.checkPreCondition();

    if (isEinzelkandidaturSelected()) {
      return null;
    }

    return cancel();
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return true;
  }

  private boolean isEinzelkandidaturSelected() {
    return isEntitySet() && getEinzelkandidat().isEinzelbewerber();
  }

  private Gebiet getGebiet() {
    return getEntity().getGebiet();
  }

  public String getEinzelkandidaturName() {
    if (isEinzelkandidaturSelected()) {
      String name = getEntity().getFamilienname();

      if (isBlank(name)) {
        name = getEntity().getNamePraesentation();
      }

      return name;
    }

    return "";
  }

  public String getGebietName() {
    if (isEinzelkandidaturSelected()) {
      return gebietNummerFormatter.getNameMitNummer(getGebiet());
    }

    return "";
  }

  private Wahl getWahl() {
    return getGebiet().getWahl();
  }

  protected Wahlart getWahlart() {
    return getWahl().getWahlart();
  }

  protected Direktkandidat getEinzelkandidat() {
    return getEntity().getDirektkandidat();
  }

  protected Gruppe getEinzelbewerber() {
    return getEntity().getGruppe();
  }

  protected Collection<Wahlvorschlagsdokument> getWahlvorschlagsdokumente() {
    if (wahlvorschlagsdokumente == null) {
      wahlvorschlagsdokumente = findWahlvorschlagsdokumente();
    }

    return wahlvorschlagsdokumente;
  }

  private Collection<Wahlvorschlagsdokument> findWahlvorschlagsdokumente() {
    return wahlvorschlagsdokumentExtendedDAO.findByWahlvorschlag(getEinzelkandidat());
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Direktkandidatur einzelkandidatur) {
    boolean readonly = false;

    einzelkandidaturViewFormBuilder.addProperties(formBuilder, einzelkandidatur, readonly);

    wahlvorschlagsdokumenteViewFormBuilder.addProperties(formBuilder, getSelectedWahl(), getEinzelkandidat(), getWahlvorschlagsdokumente(), readonly);
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.DIREKTKANDIDATUR_EDIT)
  public String save() {
    // ELECT-2788: Schließe den Konflikt, da er evtl. gelöst wurde.
    personenKonfliktConversationSelect.clearEntity();

    Direktkandidatur einzelkandidatur = getEntity();
    Direktkandidat einzelkandidat = getEinzelkandidat();

    einzelkandidaturViewFormBuilder.preSaveEntity(einzelkandidatur);

    einzelkandidatEdit.save(einzelkandidat);

    wahlvorschlagReihenfolgeBestaetigenEvent.sendWahlvorschlagReihenfolgeBestaetigenEvent(einzelkandidat.getPk());

    addMessageSaveSuccess(einzelkandidatur);

    conversationStore.close();

    return goBack(getParentViewId());
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.DIREKTKANDIDATUR_DELETE)
  public String delete() {
    einzelkandidatEdit.delete(getEinzelkandidat());

    addMessageDeleteSuccess();

    conversationStore.close();

    return getParentViewId();
  }

  public boolean isBtnSaveAndErsatzkandidaturCreateRendered() {
    // ELECT-2788: Keine Option bei der Bearbeitung eines Konflikts.
    if (personenKonfliktConversationSelect.isSelected()) {
      return false;
    }

    return hasPermission(UseCasePermission.ERSATZKANDIDATUR_CREATE) && ersatzkandidaturCreateViewResolver.isUntergeordneteErsatzkandidaturCreatable(getWahl(), getEntity());
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERSATZKANDIDATUR_CREATE)
  public String saveAndErsatzkandidaturCreate() {
    // NOTE, dass die Referenz VOR dem Speichern geholt werden muss, da der ConversationStore anschließend geschlossen wird!
    uebergeordneteKandidaturSelect.setEntity(getEntity());

    save();

    return ersatzkandidaturCreateViewResolver.getViewId(getMandant());
  }

  @Override
  protected FormBuilder createFormBuilder() {
    return new FormBuilder(formBuilderConfig);
  }
}
